local data = SkillTreeTweakData.init
function SkillTreeTweakData:init(tweak_data)
	data(self, tweak_data)
	local digest = function(value)
		return Application:digest_value(value, true)
	end
	self.tier_unlocks = {
		digest(0),
		digest(1),
		digest(6),
		digest(13)
	}

self.skill_pages_order = {
		"mastermind",
		"enforcer",
		"technician",
		"ghost",
		"hoxton",
		"joat"
}

--set 1			Master Enforcer
		self.skills.joat_1_11 = { -- 1 1		Combat Underdog
			["name_id"] = "joat_1_11_name",
			["desc_id"] = "joat_1_11_desc",
			["icon_xy"] = {1, 8},
			[1] = {
				upgrades = {
					"temporary_revive_damage_reduction_1",
					"player_revive_damage_reduction_1",
					"cable_tie_quantity",
					"cable_tie_interact_speed_multiplier",
					"player_stability_increase_bonus_1",
					"player_damage_multiplier_outnumbered",
					"player_armor_regen_time_mul_1",
					"player_flashbang_multiplier_1",
					"player_increased_pickup_area_1"
				},
				cost = self.costs.default
			},
			[2] = {
				upgrades = {
					"player_revive_health_boost",
					"team_damage_hostage_absorption",
					"player_not_moving_accuracy_increase_bonus_1",
					"player_damage_dampener_outnumbered",
					"player_flashbang_multiplier_2",
					"player_double_drop_1"
				},
				cost = self.costs.pro
			}
		}
	
		self.skills.joat_1_21 = { -- 2 1		Quick CQB
				["name_id"] = "joat_1_21_name",
				["desc_id"] = "joat_1_21_desc",
				["icon_xy"] = {1, 1},
				[1] = {
					upgrades = {
						"first_aid_kit_deploy_time_multiplier",
						"player_intimidate_range_mul",
						"player_intimidate_aura",
						"assault_rifle_enter_steelsight_speed_multiplier",
						"snp_enter_steelsight_speed_multiplier",
						"player_steelsight_normal_movement_speed",
						"assault_rifle_zoom_increase",
						"shotgun_reload_speed_multiplier_1",
						"shotgun_enter_steelsight_speed_multiplier",
						"player_interacting_damage_multiplier",
						"player_level_2_armor_addend",
						"temporary_no_ammo_cost_1"
					},
					cost = self.costs.hightier
				},
				[2] = {
					upgrades = {
						"first_aid_kit_damage_reduction_upgrade",
						"player_convert_enemies_interaction_speed_multiplier",
						"snp_zoom_increase",
						"assault_rifle_move_spread_index_addend",
						"snp_move_spread_index_addend",
						"shotgun_reload_speed_multiplier_2",
						"player_level_3_armor_addend",
						"player_level_4_armor_addend",
						"temporary_no_ammo_cost_2"
					},
					cost = self.costs.hightierpro
				}
			}

		self.skills.joat_1_22 = { -- 2 2		Killer Impact
				["name_id"] = "joat_1_22_name",
				["desc_id"] = "joat_1_22_desc",
				["icon_xy"] = {2, 0},
				[1] = {
					upgrades = {
						"player_revive_damage_reduction_level_1",
						"player_convert_enemies",
						"player_convert_enemies_max_minions_1",
						"player_convert_enemies_health_multiplier",
						"weapon_single_spread_index_addend",
						"shotgun_recoil_index_addend",
						"shotgun_damage_multiplier_1",
						"carry_throw_distance_multiplier",
						"saw_secondary",
						"saw_extra_ammo_multiplier"
					},
					cost = self.costs.hightier
				},
				[2] = {
					upgrades = {
						"player_revive_damage_reduction_level_2",
						"player_convert_enemies_damage_multiplier",
						"player_convert_enemies_max_minions_2",
						"single_shot_accuracy_inc_1",
						"shotgun_damage_multiplier_2",
						"player_armor_carry_bonus_1",
						"player_saw_speed_multiplier_2",
						"saw_lock_damage_multiplier_2"
					},
					cost = self.costs.hightierpro
				}
			}
			
		self.skills.joat_1_31 = { -- 3 1		Up Far Away
				["name_id"] = "joat_1_31_name",
				["desc_id"] = "joat_1_31_desc",
				["icon_xy"] = {4, 5},
				[1] = {
					upgrades = {
						"first_aid_kit_quantity_increase_1",
						"first_aid_kit_quantity_increase_2",
						"player_civ_calming_alerts",
						"player_civ_intimidation_mul",
						"player_marked_enemy_extra_damage",
						"player_marked_inc_dmg_distance_1",
						"shotgun_steelsight_accuracy_inc_1",
						"team_armor_regen_time_multiplier",
						"ammo_bag_quantity"
					},
					cost = self.costs.hightier
				},
				[2] = {
					upgrades = {
						"first_aid_kit_auto_recovery_1",
						"player_super_syndrome_1",
						"weapon_steelsight_highlight_specials",
						"player_mark_enemy_time_multiplier",
						"shotgun_steelsight_range_inc_1",
						"player_shield_knock",
						"ammo_bag_ammo_increase1"
					},
					cost = self.costs.hightierpro
				}
			}

		self.skills.joat_1_32 = { -- 3 2		Close Combat
				["name_id"] = "joat_1_32_name",
				["desc_id"] = "joat_1_32_desc",
				["icon_xy"] = {1, 9},
				[1] = {
					upgrades = {
						"doctor_bag_quantity",
						"player_minion_master_speed_multiplier",
						"player_passive_convert_enemies_health_multiplier_1",
						"assault_rifle_reload_speed_multiplier",
						"shotgun_hip_run_and_shoot_1",
						"shotgun_hip_rate_of_fire_1",
						"player_headshot_regen_armor_bonus_1",
						"saw_enemy_slicer",
						"saw_ignore_shields_1"
					},
					cost = self.costs.hightier
				},
				[2] = {
					upgrades = {
						"doctor_bag_amount_increase1",
						"player_minion_master_health_multiplier",
						"player_passive_convert_enemies_health_multiplier_2",
						"temporary_single_shot_fast_reload_1",
						"shotgun_magazine_capacity_inc_1",
						"player_headshot_regen_armor_bonus_2",
						"saw_panic_when_kill_1"
					},
					cost = self.costs.hightierpro
				}
			}

		self.skills.joat_1_41 = { -- 4 1		Inspireing Overkill
				["name_id"] = "joat_1_41_name",
				["desc_id"] = "joat_1_41_desc",
				["icon_xy"] = {1, 7},
				[1] = {
					upgrades = {
						"cooldown_long_dis_revive",
						"player_revive_interaction_speed_multiplier",
						"player_hostage_health_regen_addend_1",
						"head_shot_ammo_return_1",
						"player_overkill_damage_multiplier",
						"player_armor_multiplier",
						"extra_ammo_multiplier1",
						"player_pick_up_ammo_multiplier"
					},
					cost = self.costs.hightier
				},
				[2] = {
					upgrades = {
						"player_morale_boost",
						"player_hostage_health_regen_addend_2",
						"head_shot_ammo_return_2",
						"weapon_swap_speed_multiplier",
						"player_overkill_all_weapons",
						"body_armor6",
						"player_pick_up_ammo_multiplier_2",
						"player_regain_throwable_from_ammo_1"
					},
					cost = self.costs.hightierpro
				}
			}
			
			
--set 2			Technical Ghost
		self.skills.joat_2_11 = { -- 1 1		Chameleon Law
			["name_id"] = "joat_2_11_name",
			["desc_id"] = "joat_2_11_desc",
			["icon_xy"] = {2, 9},
			[1] = {
				upgrades = {
					"sentry_gun_cost_reduction_1",
					"player_drill_fix_interaction_speed_multiplier",
					"player_trip_mine_deploy_time_multiplier_2",
					"player_weapon_accuracy_increase_1",
					"player_suspicion_bonus",
					"player_sec_camera_highlight_mask_off",
					"player_special_enemy_highlight_mask_off",
					"player_stamina_regen_timer_multiplier",
					"player_stamina_regen_multiplier",
					"temporary_damage_speed_multiplier"
				},
				cost = self.costs.default
			},
			[2] = {
				upgrades = {
					"sentry_gun_shield",
					"player_drill_alert",
					"player_silent_drill",
					"player_drill_autorepair_1",
					"player_stability_increase_bonus_2",
					"player_mask_off_pickup",
					"player_small_loot_multiplier_1",
					"player_run_speed_multiplier",
					"player_run_dodge_chance",
					"player_damage_speed_multiplier_send"
				},
				cost = self.costs.pro
			}
		}	
	
		self.skills.joat_2_21 = { -- 2 1		Targeting Sense

				["name_id"] = "joat_2_21_name",
				["desc_id"] = "joat_2_21_desc",
				["icon_xy"] = {1, 1},
				[1] = {
					upgrades = {
						"sentry_gun_spread_multiplier",
						"sentry_gun_rot_speed_multiplier",
						"trip_mine_explosion_size_multiplier_1",
						"weapon_knock_down_1",
						"player_corpse_dispose_amount_2",
						"player_extra_corpse_dispose_amount",
						"player_movement_speed_multiplier",
						"player_climb_speed_multiplier_1",
						"player_camouflage_bonus_1",
						"player_camouflage_bonus_2"
					},
					cost = self.costs.hightier
				},
				[2] = {
					upgrades = {
						"sentry_gun_extra_ammo_multiplier_1",
						"trip_mine_damage_multiplier_1",
						"weapon_knock_down_2",
						"bodybags_bag_quantity",
						"player_can_free_run",
						"player_run_and_reload",
						"player_silencer_concealment_penalty_decrease_1",
						"player_silencer_concealment_increase_1"
					},
					cost =self.costs.hightierpro
				}
			}
			
		self.skills.joat_2_22 = { -- 2 2		Cover Expert
				["name_id"] = "joat_2_22_name",
				["desc_id"] = "joat_2_22_desc",
				["icon_xy"] = {7, 1},
				[1] = {
					upgrades = {
						"sentry_gun_cost_reduction_2",
						"player_drill_speed_multiplier1",
						"player_hip_fire_accuracy_inc_1",
						"player_standstill_omniscience",
						"player_buy_bodybags_asset",
						"player_additional_assets",
						"player_melee_concealment_modifier",
						"weapon_silencer_recoil_index_addend",
						"weapon_silencer_enter_steelsight_speed_multiplier"
					},
					cost = self.costs.hightier
				},
				[2] = {
					upgrades = {
						"sentry_gun_armor_multiplier",
						"player_drill_speed_multiplier2",
						"player_weapon_movement_stability_1",
						"player_cleaner_cost_multiplier",
						"player_buy_spotter_asset",
						"player_ballistic_vest_concealment_1",
						"weapon_silencer_spread_index_addend"
					},
					cost = self.costs.hightierpro
				}
			}
			
		self.skills.joat_2_31 = { -- 3 1		Steady Wind
				["name_id"] = "joat_2_31_name",
				["desc_id"] = "joat_2_31_desc",
				["icon_xy"] = {0, 0},
				--note this is a good icon for this when done {1, 2}
				[1] = {
					upgrades = {
						"sentry_gun_silent",
						"sentry_gun_ap_bullets",
						"shape_charge_quantity_increase_1",
						"trip_mine_quantity_increase_1",
						"player_run_and_shoot_1",
						"player_tape_loop_duration_1",
						"player_tape_loop_duration_2",
						"player_armor_depleted_stagger_shot_1",
						"player_detection_risk_add_crit_chance_1"
					},
					cost = self.costs.hightier
				},
				[2] = {
					upgrades = {
						"sentry_gun_damage_multiplier",
						"sentry_gun_fire_rate_reduction_1",
						"shape_charge_quantity_increase_2",
						"trip_mine_quantity_increase_2",
						"player_automatic_faster_reload_1",
						"player_pick_lock_hard",
						"player_pick_lock_easy_speed_multiplier_2",
						"player_armor_depleted_stagger_shot_2",
						"player_detection_risk_add_crit_chance_2"
					},
					cost = self.costs.hightierpro
				}
			}
			
		self.skills.joat_2_32 = { -- 3 2		Kickstarter Need
				["name_id"] = "joat_2_32_name",
				["desc_id"] = "joat_2_32_desc",
				["icon_xy"] = {2, 8},
				[1] = {
					upgrades = {
						"deploy_interact_faster_1",
						"player_drill_autorepair_2",
						"player_automatic_mag_increase_1",
						"ecm_jammer_duration_multiplier",
						"ecm_jammer_feedback_duration_boost",
						"player_taser_malfunction",
						"player_taser_self_shock",
						"weapon_silencer_damage_multiplier_1"
					},
					cost = self.costs.hightier
				},
				[2] = {
					upgrades = {
						"second_deployable_1",
						"player_drill_melee_hit_restart_chance_1",
						"player_ap_bullets_1",
						"ecm_jammer_can_open_sec_doors",
						"player_escape_taser_1",
						"weapon_silencer_damage_multiplier_2"
					},
					cost = self.costs.hightierpro
				}
			}

		self.skills.joat_2_41 = { -- 4 1		Trap Bastard
				["name_id"] = "joat_2_41_name",
				["desc_id"] = "joat_2_41_desc",
				["icon_xy"] = {2, 1},
				[1] = {
					upgrades = {
						"sentry_gun_quantity_1",
						"trip_mine_fire_trap_1",
						"weapon_automatic_head_shot_add_1",
						"ecm_jammer_quantity_increase_1",
						"ecm_jammer_duration_multiplier_2",
						"player_detection_risk_add_dodge_chance_1",
						"player_unseen_increased_crit_chance_1"
					},
					cost = self.costs.hightier
				},
				[2] = {
					upgrades = {
						"sentry_gun_quantity_2",
						"trip_mine_fire_trap_2",
						"weapon_automatic_head_shot_add_2",
						"ecm_jammer_feedback_duration_boost_2",
						"ecm_jammer_affects_pagers",
						"player_detection_risk_add_dodge_chance_2",
						"player_unseen_increased_crit_chance_2"
					},
					cost = self.costs.hightierpro
				}
			}
			
			
--set 3			Fugitive
		self.skills.joat_3_11 = { -- 1 1		Nine Equilibrium Arts
			["name_id"] = "joat_3_11_name",
			["desc_id"] = "joat_3_11_desc",
			["icon_xy"] = {1, 8},
			[1] = {
				upgrades = {
					"pistol_swap_speed_multiplier",
					"player_bleed_out_health_multiplier",
					"player_melee_knockdown_mul"
				},
				cost = self.costs.default
			},
			[2] = {
				upgrades = {
					"pistol_spread_index_addend",
					"player_additional_lives_1",
					"player_melee_damage_dampener"
				},
				cost = self.costs.pro
			}
		}
	
		self.skills.joat_3_21 = { -- 2 1		Blood Running Guns
				["name_id"] = "joat_3_21_name",
				["desc_id"] = "joat_3_21_desc",
				["icon_xy"] = {1, 1},
				[1] = {
					upgrades = {
						"pistol_magazine_capacity_inc_1",
						"player_temp_swap_weapon_faster_1",
						"player_temp_reload_weapon_faster_1",
						"player_melee_damage_stacking_1"
					},
					cost = self.costs.hightier
				},
				[2] = {
					upgrades = {
						"pistol_fire_rate_multiplier",
						"player_temp_increased_movement_speed_1",
						"player_temp_melee_kill_increase_reload_speed_1"
					},
					cost = self.costs.hightierpro
				}
			}

		self.skills.joat_3_22 = { -- 2 2		Pumping Up Akimbo
				["name_id"] = "joat_3_22_name",
				["desc_id"] = "joat_3_22_desc",
				["icon_xy"] = {2, 0},
				[1] = {
					upgrades = {
						"akimbo_recoil_index_addend_2",
						"akimbo_extra_ammo_multiplier_1",
						"player_revived_damage_resist_1",
						"player_non_special_melee_multiplier"
					},
					cost = self.costs.hightier
				},
				[2] = {
					upgrades = {
						"akimbo_extra_ammo_multiplier_2",
						"akimbo_recoil_index_addend_3",
						"player_revived_health_regain_1",
						"player_melee_damage_multiplier"
					},
					cost = self.costs.hightierpro
				}
			}
			
		self.skills.joat_3_31 = { -- 3 1		One Counter Sawn
				["name_id"] = "joat_3_31_name",
				["desc_id"] = "joat_3_31_desc",
				["icon_xy"] = {4, 5},
				[1] = {
					upgrades = {
						"pistol_damage_addend_1",
						"temporary_berserker_damage_multiplier_1",
						"temporary_berserker_damage_multiplier_2",
						"player_counter_strike_melee"
					},
					cost = self.costs.hightier
				},
				[2] = {
					upgrades = {
						"pistol_damage_addend_2",
						"player_berserker_no_ammo_cost",
						"player_counter_strike_spooc"
					},
					cost = self.costs.hightierpro
				}
			}

		self.skills.joat_3_32 = { -- 3 2		Desperado Death Berserke
				["name_id"] = "joat_3_32_name",
				["desc_id"] = "joat_3_32_desc",
				["icon_xy"] = {1, 9},
				[1] = {
					upgrades = {
						"pistol_stacked_accuracy_bonus_1",
						"player_cheat_death_chance_1",
						"player_melee_damage_health_ratio_multiplier"
					},
					cost = self.costs.hightier
				},
				[2] = {
					upgrades = {
						"pistol_reload_speed_multiplier",
						"player_cheat_death_chance_2",
						"player_damage_health_ratio_multiplier"
					},
					cost = self.costs.hightierpro
				}
			}

		self.skills.joat_3_41 = { -- 4 1		Messiah Trigger Frenzy
				["name_id"] = "joat_3_41_name",
				["desc_id"] = "joat_3_41_desc",
				["icon_xy"] = {1, 7},
				[1] = {
					upgrades = {
						"pistol_stacking_hit_damage_multiplier_1",
						"player_messiah_revive_from_bleed_out_1",
					},
					cost = self.costs.hightier
				},
				[2] = {
					upgrades = {
						"pistol_stacking_hit_damage_multiplier_2",
						"player_recharge_messiah_1",
					},
					cost = self.costs.hightierpro
				}
			}
			
			
--joat	
table.insert(self.trees,{
			name_id = "joat_tree1",
			background_texture = "guis/textures/pd2/skilltree/bg_mastermind",
			unlocked = true,
			skill = "joat",
			tiers = {
				{	
					"joat_1_11"
				},
				{
					"joat_1_21",
					"joat_1_22"
				},
				{
					"joat_1_31",
					"joat_1_32"
				},
				{"joat_1_41"}
			}
		})	

		
--set 2
table.insert(self.trees,{
			name_id = "joat_tree2",
			background_texture = "guis/textures/pd2/skilltree/bg_mastermind",
			unlocked = true,
			skill = "joat",
			tiers = {
				{	
					"joat_2_21"
				},
				{
					"joat_2_31",
					"joat_2_11"
				},
				{
					"joat_2_22",
					"joat_2_32"
				},
				{"joat_2_41"}
			}
		})			


table.insert(self.trees,{
			name_id = "joat_tree3",
			background_texture = "guis/textures/pd2/skilltree/bg_mastermind",
			unlocked = true,
			skill = "joat",
			tiers = {
				{	
					"joat_3_21"
				},
				{
					"joat_3_31",
					"joat_3_11"
				},
				{
					"joat_3_22",
					"joat_3_32"
				},
				{"joat_3_41"}
			}
		})			

self.skilltree.joat = {
	name_id = "joat_title",
	desc_id = "joat_desc"
}


end